<?php
 namespace imwprobot\modules\data; use imwprobot\modules; use imwprobot\modules\Logger; use imwprobot\modules\lib\Constant; use imwprobot\modules\lib\Proxy; use imwprobot\src\ProxyAPI; use imwpf\modules\lock; use imwpf\modules\AutoLogger; class Task { private $_db = null; private $_subTaskTable; private $taskTable; private $postTable; public function __construct() { $this->_db = $GLOBALS['wpdb']; $this->taskTable = $this->_db->prefix . 'imwprobot_tasks'; $this->postTable = $this->_db->prefix . 'imwprobot_posts'; $this->_subTaskTable = $this->_db->prefix . 'imwprobot_posts'; } public function add($) { $ = array('name' => sanitize_text_field($['name']), 'entry_interval' => intval($['entry_interval']), 'content_interval' => intval($['content_interval']), 'crawl_rule' => intval($['crawl_rule']), 'publish_rule' => intval($['publish_rule']), 'post_status' => intval($['post_status']), 'post_author' => intval($['post_author']), 'check_update' => intval($['check_update']), 'publish_order' => intval($['publish_order']), 'cookie' => trim($['cookie']), 'watermark_name' => trim($['watermark_name']), 'forbid_img_download' => intval($['forbid_img_download']), 'post_category' => trim($['post_category']), 'tags_input' => trim($['tags_input']), 'forbid_same_title' => intval($["forbid_same_title"])); $ = array('url' => trim($['url']), 'value' => json_encode($), 'last_execute' => time(), 'next_execute' => time(), 'content_offset' => intval($['content_offset']), 'max_page' => intval($['max_page']), 'task_status' => intval($['task_status'])); if ($['action'] == 'edit') { $ = intval($['id']); if ($ && $this->_db->update($this->taskTable, $, array('id' => $))) { return $; } return false; } if ($['action'] == 'add') { $['posts_count'] = 0; $['uncompleted_count'] = 0; $this->_db->insert($this->taskTable, $); return $this->_db->insert_id; } return false; } public function pause($) { if (!$) { return false; } return $this->_db->update($this->taskTable, array('task_status' => 0), array('id' => $)); } public function start($) { if (!$) { return false; } return $this->_db->update($this->taskTable, array('task_status' => 1), array('id' => $)); } public function get($, $ = true) { $ = $this->_db->prepare("SELECT * FROM {$this->taskTable} WHERE `id` = %d LIMIT 1", array($)); $ = $this->_db->get_row($, ARRAY_A); if (!$) { return false; } $ = array(); if ($) { $ = json_decode($['value'], true); } return array_merge($, $); } public function getExecuteable($ = null, $ = null) { if ($) { $ = $this->get($); } else { $ = $this->_db->prepare("SELECT * FROM {$this->taskTable} WHERE `next_execute` < %d AND `task_status`=1 ORDER BY next_execute ASC LIMIT 1", array(time())); $ = $this->_db->get_row($, ARRAY_A); if ($) { $ = json_decode($['value'], true); $ = array_merge($, $); } } if (!$) { return array(); } if ($) { $ = $this->_db->prepare("SELECT * FROM {$this->postTable} WHERE id=%d and task_id=%d LIMIT 1", array($, $['id'])); } else { $ = $this->_db->prepare("SELECT * FROM {$this->postTable} WHERE id>%d and task_id=%d ORDER BY id ASC LIMIT 1", array($['content_offset'], $['id'])); } $['post'] = $this->_db->get_row($, ARRAY_A); if ($['post']) { $['url'] = $['post']['url']; } if ($) { $['not_update_post_offset'] = true; } else { $['not_update_post_offset'] = false; } if (!empty($['post'])) { $ = json_decode($["post"]["content"], true); $ = $["post"]["id"]; $this->($, $); if ($["rtimes"] > 7 && !$ && !$) { Logger::getInstance()->addInfo('getExecuteable', $); $this->($); return array(); } } Logger::getInstance()->addInfo('getExecuteable', $); return $; } public function lists($ = 1, $ = 10) { $ = ($ - 1) * $ . ',' . $; return $this->_db->get_results("SELECT * FROM {$this->taskTable} LIMIT {$}", ARRAY_A); } public function count() { return $this->_db->get_var("SELECT count(1) FROM {$this->taskTable}"); } public function delete($) { $ = new TaskPost(); $->deleteByTaskId($); return $this->_db->delete($this->taskTable, array('id' => $)); } public function deleteQueue($) { $ = $this->get($, false); if (!$) { return false; } $ = new TaskPost(); $->deleteByTaskId($); $ = array('posts_count' => 0, 'uncompleted_count' => 0, 'content_offset' => 0); return $this->_db->update($this->taskTable, $, array('id' => $)); } public function execute($ = null, $ = null) { if (!$ && !$) { if (!lock\File::aquire(__DIR__ . '/spider.lock')) { throw new \Exception("任务锁定，需要等会儿", 1); } } $ = time(); $ = $this->getExecuteable($, $); if (!$) { lock\File::release(__DIR__ . "/spider.lock"); throw new \Exception("暂时没有任务需要执行", 1); } try { $ = $this->($); } catch (\Exception $) { lock\File::release(__DIR__ . "/spider.lock"); Logger::getInstance()->addInfo('execute.error', $->getMessage()); throw new \Exception($->getMessage(), $->getCode()); } lock\File::release(__DIR__ . "/spider.lock"); Logger::getInstance()->addInfo('execute.expend', time() - $ . 's'); return $; } public function import($) { if (empty($['crawl_rule']) || empty($['publish_rule'])) { throw new \Exception("导入的内容有误", 1); } $ = wp_date('Y-m-dTH:i:s'); $ = new CrawlRule(); $ = $->add($['crawl_rule']['name'] . $, $['crawl_rule']['value']); if ($ <= 0) { throw new \Exception("导入抓取规则失败", 1); } $ = new PublishRule(); $ = $->add($['publish_rule']['name'] . $, $['publish_rule']['value']); if ($ <= 0) { throw new \Exception("导入发布规则失败", 1); } $ = $['task']; $['crawl_rule'] = $; $['publish_rule'] = $; $['content_offset'] = 0; $['posts_count'] = 0; $['uncompleted_count'] = 0; $['name'] .= $; $['action'] = 'add'; $ = $this->add($); if ($ <= 0) { throw new \Exception("导入任务失败", 1); } return true; } private function ($) { $ = new CrawlRule(); $ = $->get($['crawl_rule']); if (!$) { Logger::getInstance()->addInfo('execute.rule', '规则不存在'); Logger::getInstance()->addInfo('errmsg', '采集规则不存在'); throw new \Exception("采集模块不存在", 1); } $ = new PublishRule(); $ = $->get($['publish_rule']); if (!$) { Logger::getInstance()->addInfo('execute.publishRule', '规则不存在'); Logger::getInstance()->addInfo('errmsg', '发布规则不存在'); throw new \Exception("发布模块不存在", 1); } $ = new modules\spider\Spider(); try { if (!empty($['post'])) { $ = json_decode($['post']['content'], true); } $ = isset($['level']) ? $['level'] : 0; $ = isset($['title']) ? $['title'] : ''; $ = !empty($['cookie']) ? $['cookie'] : ''; $ = !empty($['page']['proxy']) ? $['page']['proxy'] : 'no'; if (empty($) && !empty($["page"]["cookie"])) { $ = $["page"]["cookie"]; } $ = ""; if ($ == 'yes') { $ = new Proxy(); $ = $->randomGet(); } else { if ($ == "api") { $ = ProxyAPI::get(); } } AutoLogger::info("execute.use_proxy", $); AutoLogger::info("execute.proxy_data", $); $ = $->get($['url'], $, $, $, $, $, $); AutoLogger::debug("Task.result", $); } catch (\Exception $) { $ = $->getCode(); if ($ == Constant::ERR_BALANCE_EMPTY) { update_option('imwprobot_balance', -1) && add_option('imwprobot_balance', -1); } if ($ == Constant::ERR_API_KEY || $ == Constant::ERR_TOKEN || $ == Constant::ERR_BALANCE_EMPTY) { $this->pause($['id']); } $this->($); Logger::getInstance()->addInfo('execute.spider', $->getMessage()); Logger::getInstance()->addInfo('errmsg', $->getMessage()); throw new \Exception($->getMessage(), $->getCode()); } $ = new TaskPost(); $ = $->add($, $); Logger::getInstance()->addInfo('new_post_count', $); $ = null; if (isset($['rules']["publish_type"])) { if ($['rules']["publish_type"] == "sqlite") { $['publish_rule'] = $['rules']['sqlite']; $ = new PublishSQLite(); } else { if ($['rules']['publish_type'] == "term") { $['publish_rule'] = $['rules']['term']; $ = new PublishToCategory(); } else { $['publish_rule'] = isset($['rules']['content']) ? $['rules']['content'] : $['rules']; $ = new PublishToWP(); } } } else { $['publish_rule'] = isset($['rules']['content']) ? $['rules']['content'] : $['rules']; $ = new PublishToWP(); } $ = 0; foreach ($['content'] as $ => $) { if ($ == 0) { $ = $->publish($, $); if (!empty($['post']['id']) && $ > 0) { $->updatePostID($, $['post']['id']); } continue; } $['post']['id'] = 0; $->publish($, $); } if ($ == 0) { Logger::getInstance()->addInfo('execute.addpost', '添加文章失败'); Logger::getInstance()->addInfo('errmsg', '添加文章失败'); } $this->($, $); return $; } private function ($) { if (empty($['post'])) { $ = array('next_execute' => time() + $['entry_interval']); if ($['content_offset'] > 0 && $['check_update'] != 1) { $['task_status'] = 0; } Logger::getInstance()->addInfo('update_task', $); return $this->_db->update($this->taskTable, $, array('id' => $['id'])); } $ = json_decode($['post']['content'], true); if ($['rtimes'] > 6) { $ = array('content_offset' => $['post']['id'], 'next_execute' => time() + $['content_interval'], 'uncompleted_count' => $['uncompleted_count'] - 1); Logger::getInstance()->addInfo('update_task', $); return $this->_db->update($this->taskTable, $, array('id' => $['id'])); } $ = array('next_execute' => time() + $['content_interval']); Logger::getInstance()->addInfo('update_task', $); $this->_db->update($this->taskTable, $, array('id' => $['id'])); } public function incrementTaskPostCount($, $ = 1) { $ = $this->_db->get_var($this->_db->prepare("SELECT `posts_count` FROM {$this->taskTable} WHERE id = %d", $)); return $this->_db->update($this->taskTable, array("posts_count" => $ + $), array('id' => $, "posts_count" => $)); } private function ($, $) { if (!empty($['post'])) { $ = $['content_interval']; } else { $ = $['entry_interval']; } $ = array('next_execute' => time() + $, 'posts_count' => $['posts_count'] + $, 'uncompleted_count' => $['uncompleted_count'] + $); if (!empty($['post']['id'])) { if (!$['not_update_post_offset']) { $['content_offset'] = $['post']['id']; } if (empty($['post']['post_id'])) { $['uncompleted_count'] = $['uncompleted_count'] - 1; } } else { if ($['content_offset'] > 0) { if ($['check_update'] != 1) { $['task_status'] = 0; } } else { $['next_execute'] = time() + $['content_interval']; } } Logger::getInstance()->addInfo('update_task', $); return $this->_db->update($this->taskTable, $, array('id' => $['id'])); } private function ($, $) { $['rtimes'] += 1; return $this->_db->update($this->_subTaskTable, array('content' => json_encode($)), array('id' => $)); } }