<?php
 namespace imwprobot\src; class Markdown { private $_commonWhiteList = 'kbd|b|i|strong|em|sup|sub|br|code|del|a|hr|small'; private $_blockHtmlTags = 'p|div|h[1-6]|blockquote|pre|table|dl|ol|ul|address|form|fieldset|iframe|hr|legend|article|section|nav|aside|hgroup|header|footer|figcaption|svg|script|noscript'; private $_specialWhiteList = array('table' => 'table|tbody|thead|tfoot|tr|td|th'); private $_footnotes; private $_html = false; private $_line = false; private $blockParsers = array(array('code', 10), array('shtml', 20), array('pre', 30), array('ahtml', 40), array('shr', 50), array('list', 60), array('math', 70), array('html', 80), array('footnote', 90), array('definition', 100), array('quote', 110), array('table', 120), array('sh', 130), array('mh', 140), array('dhr', 150), array('default', 9999)); private $_blocks; private $_current; private $_pos; private $_definitions; private $_hooks = array(); private $_holders; private $_uniqid; private $_id; private $_parsers = array(); public function makeHtml($) { $this->_footnotes = array(); $this->_definitions = array(); $this->_holders = array(); $this->_uniqid = md5(uniqid()); $this->_id = 0; usort($this->blockParsers, function ($, $) { return $[1] < $[1] ? -1 : 1; }); foreach ($this->blockParsers as $) { list($) = $; if (isset($[2])) { $this->_parsers[$] = $[2]; } else { $this->_parsers[$] = array($this, 'parseBlock' . ucfirst($)); } } $ = $this->initText($); $ = $this->parse($); $ = $this->makeFootnotes($); $ = $this->optimizeLines($); return $this->call('makeHtml', $); } public function enableHtml($ = true) { $this->_html = $; } public function enableLine($ = true) { $this->_line = $; } public function hook($, $) { $this->_hooks[$][] = $; } public function makeHolder($) { $ = "\r" . $this->_uniqid . $this->_id . "\r"; $this->_id++; $this->_holders[$] = $; return $; } public function initText($) { $ = str_replace(array("\t", "\r"), array('    ', ''), $); return $; } public function makeFootnotes($) { if (count($this->_footnotes) > 0) { $ .= '<div class="footnotes"><hr><ol>'; $ = 1; while ($ = array_shift($this->_footnotes)) { if (is_string($)) { $ .= " <a href=\"#fnref-{$}\" class=\"footnote-backref\">&#8617;</a>"; } else { $[count($) - 1] .= " <a href=\"#fnref-{$}\" class=\"footnote-backref\">&#8617;</a>"; $ = count($) > 1 ? $this->parse(implode("\n", $)) : $this->parseInline($[0]); } $ .= "<li id=\"fn-{$}\">{$}</li>"; $++; } $ .= '</ol></div>'; } return $; } public function parse($, $ = false, $ = 0) { $ = $this->parseBlock($, $); $ = ''; if ($ && count($) == 1 && $[0][0] == 'normal') { $[0][3] = true; } foreach ($ as $) { list($, $, $, $) = $; $ = array_slice($, $, $ - $ + 1); $ = 'parse' . ucfirst($); $ = $this->call('before' . ucfirst($), $, $); $ = $this->{$}($, $, $ + $, $ + $); $ = $this->call('after' . ucfirst($), $, $); $ .= $; } return $; } public function releaseHolder($, $ = true) { $ = 0; while (strpos($, "\r") !== false && $ < 10) { $ = str_replace(array_keys($this->_holders), array_values($this->_holders), $); $++; } if ($) { $this->_holders = array(); } return $; } public function markLine($, $ = -1) { if ($this->_line) { $ = $ < 0 ? $ : $; return '<span class="line" data-start="' . $ . '" data-end="' . $ . '" data-id="' . $this->_uniqid . '"></span>'; } return ''; } public function markLines(array $, $) { $ = -1; return $this->_line ? array_map(function ($) use($, &$) { $++; return $this->markLine($ + $) . $; }, $) : $; } public function optimizeLines($) { $ = 0; return $this->_line ? preg_replace_callback("/class=\"line\" data\\-start=\"([0-9]+)\" data\\-end=\"([0-9]+)\" (data\\-id=\"{$this->_uniqid}\")/", function ($) use(&$) { if ($[1] != $) { $ = 'class="line" data-start="' . $ . '" data-start-original="' . $[1] . '" data-end="' . $[2] . '" ' . $[3]; } else { $ = $[0]; } $ = $[2] + 1; return $; }, $) : $; } public function call($, $) { if (empty($this->_hooks[$])) { return $; } $ = func_get_args(); $ = array_slice($, 1); foreach ($this->_hooks[$] as $) { $ = call_user_func_array($, $); $[0] = $; } return $; } public function parseInline($, $ = '', $ = true, $ = true) { $ = $this->call('beforeParseInline', $); $ = preg_replace_callback("/(^|[^\\\\])(`+)(.+?)\\2/", function ($) { return $[1] . $this->makeHolder('<code>' . htmlspecialchars($[3]) . '</code>'); }, $); $ = preg_replace_callback("/(^|[^\\\\])(\\\$+)(.+?)\\2/", function ($) { return $[1] . $this->makeHolder($[2] . htmlspecialchars($[3]) . $[2]); }, $); $ = preg_replace_callback("/\\\\(.)/u", function ($) { $ = preg_match("/^[-\\[\\]\\/\\{\\}\\(\\)\\*\\+\\?\\.\\\\^\$\\|]\$/", $[1]) ? '' : '\\'; $ = htmlspecialchars($[1]); $ = str_replace('$', '&dollar;', $); return $this->makeHolder($ . $); }, $); $ = preg_replace_callback("/<(https?:\\/\\/.+|(?:mailto:)?[_a-z0-9-\\.\\+]+@[_\\w-]+(?:\\.[a-z]{2,})+)>/i", function ($) { $ = $this->cleanUrl($[1]); $ = $this->call('parseLink', $); return $this->makeHolder("<a href=\"{$}\">{$}</a>"); }, $); $ = preg_replace_callback("/<(\\/?)([a-z0-9-]+)(\\s+[^>]*)?>/i", function ($) use($) { if ($this->_html || false !== stripos('|' . $this->_commonWhiteList . '|' . $ . '|', '|' . $[2] . '|')) { return $this->makeHolder($[0]); } else { return $this->makeHolder(htmlspecialchars($[0])); } }, $); if ($this->_html) { $ = preg_replace_callback("/<!\\-\\-(.*?)\\-\\->/", function ($) { return $this->makeHolder($[0]); }, $); } $ = str_replace(array('<', '>'), array('&lt;', '&gt;'), $); $ = preg_replace_callback("/\\[\\^((?:[^\\]]|\\\\\\]|\\\\\\[)+?)\\]/", function ($) { $ = array_search($[1], $this->_footnotes); if (false === $) { $ = count($this->_footnotes) + 1; $this->_footnotes[$] = $this->parseInline($[1], '', false); } return $this->makeHolder("<sup id=\"fnref-{$}\"><a href=\"#fn-{$}\" class=\"footnote-ref\">{$}</a></sup>"); }, $); $ = preg_replace_callback("/!\\[((?:[^\\]]|\\\\\\]|\\\\\\[)*?)\\]\\(((?:[^\\)]|\\\\\\)|\\\\\\()+?)\\)/", function ($) { $ = htmlspecialchars($this->escapeBracket($[1])); $ = $this->escapeBracket($[2]); list($, $) = $this->cleanUrl($, true); $ = empty($) ? $ : " title=\"{$}\""; return $this->makeHolder("<img src=\"{$}\" alt=\"{$}\" title=\"{$}\">"); }, $); $ = preg_replace_callback("/!\\[((?:[^\\]]|\\\\\\]|\\\\\\[)*?)\\]\\[((?:[^\\]]|\\\\\\]|\\\\\\[)+?)\\]/", function ($) { $ = htmlspecialchars($this->escapeBracket($[1])); $ = isset($this->_definitions[$[2]]) ? "<img src=\"{$this->_definitions[$[2]]}\" alt=\"{$}\" title=\"{$}\">" : $; return $this->makeHolder($); }, $); $ = preg_replace_callback("/\\[((?:[^\\]]|\\\\\\]|\\\\\\[)+?)\\]\\(((?:[^\\)]|\\\\\\)|\\\\\\()+?)\\)/", function ($) { $ = $this->parseInline($this->escapeBracket($[1]), '', false, false); $ = $this->escapeBracket($[2]); list($, $) = $this->cleanUrl($, true); $ = empty($) ? '' : " title=\"{$}\""; return $this->makeHolder("<a href=\"{$}\"{$}>{$}</a>"); }, $); $ = preg_replace_callback("/\\[((?:[^\\]]|\\\\\\]|\\\\\\[)+?)\\]\\[((?:[^\\]]|\\\\\\]|\\\\\\[)+?)\\]/", function ($) { $ = $this->parseInline($this->escapeBracket($[1]), '', false); $ = isset($this->_definitions[$[2]]) ? "<a href=\"{$this->_definitions[$[2]]}\">{$}</a>" : $; return $this->makeHolder($); }, $); $ = $this->parseInlineCallback($); $ = preg_replace("/<([_a-z0-9-\\.\\+]+@[^@]+\\.[a-z]{2,})>/i", "<a href=\"mailto:\\1\">\\1</a>", $); if ($) { $ = preg_replace_callback("/(^|[^\"])(https?:\\/\\/(www\\.)?[-a-zA-Z0-9@:%._\\+~#=]{1,256}\\b([-a-zA-Z0-9@:%_\\+.~#?&\\/=]*)|(?:mailto:)?[_a-z0-9-\\.\\+]+@[_\\w-]+(?:\\.[a-z]{2,})+)(\$|[^\"])/", function ($) { $ = $this->cleanUrl($[2]); $ = $this->call('parseLink', $[2]); return "{$[1]}<a href=\"{$}\">{$}</a>{$[5]}"; }, $); } $ = $this->call('afterParseInlineBeforeRelease', $); $ = $this->releaseHolder($, $); $ = $this->call('afterParseInline', $); return $; } public function parseInlineCallback($) { $ = preg_replace_callback("/(\\*{3})(.+?)\\1/", function ($) { return '<strong><em>' . $this->parseInlineCallback($[2]) . '</em></strong>'; }, $); $ = preg_replace_callback("/(\\*{2})(.+?)\\1/", function ($) { return '<strong>' . $this->parseInlineCallback($[2]) . '</strong>'; }, $); $ = preg_replace_callback("/(\\*)(.+?)\\1/", function ($) { return '<em>' . $this->parseInlineCallback($[2]) . '</em>'; }, $); $ = preg_replace_callback("/(\\s+|^)(_{3})(.+?)\\2(\\s+|\$)/", function ($) { return $[1] . '<strong><em>' . $this->parseInlineCallback($[3]) . '</em></strong>' . $[4]; }, $); $ = preg_replace_callback("/(\\s+|^)(_{2})(.+?)\\2(\\s+|\$)/", function ($) { return $[1] . '<strong>' . $this->parseInlineCallback($[3]) . '</strong>' . $[4]; }, $); $ = preg_replace_callback("/(\\s+|^)(_)(.+?)\\2(\\s+|\$)/", function ($) { return $[1] . '<em>' . $this->parseInlineCallback($[3]) . '</em>' . $[4]; }, $); $ = preg_replace_callback("/(~{2})(.+?)\\1/", function ($) { return '<del>' . $this->parseInlineCallback($[2]) . '</del>'; }, $); return $; } public function parseBlock($, &$) { $ = explode("\n", $); $this->_blocks = array(); $this->_current = 'normal'; $this->_pos = -1; $ = array('special' => implode("|", array_keys($this->_specialWhiteList)), 'empty' => 0, 'html' => false); foreach ($ as $ => $) { $ = $this->getBlock(); $ = array($, $, $, &$, $); if ($this->_current != 'normal') { $ = call_user_func_array($this->_parsers[$this->_current], $); if (!$) { continue; } } foreach ($this->_parsers as $ => $) { if ($ != $this->_current) { $ = call_user_func_array($, $); if (!$) { break; } } } } return $this->optimizeBlocks($this->_blocks, $); } public function parseBlockList($, $, $, &$) { if ($this->isBlock('list') && !preg_match("/^\\s*\\[((?:[^\\]]|\\]|\\[)+?)\\]:\\s*(.+)\$/", $)) { if (preg_match("/^(\\s*)(~{3,}|`{3,})([^`~]*)\$/i", $)) { return true; } elseif ($['empty'] <= 1 && preg_match("/^(\\s*)\\S+/", $, $) && strlen($[1]) >= $[3][0] + $['empty']) { $['empty'] = 0; $this->setBlock($); return false; } elseif (preg_match("/^(\\s*)\$/", $) && $['empty'] == 0) { $['empty']++; $this->setBlock($); return false; } } if (preg_match("/^(\\s*)((?:[0-9]+\\.)|\\-|\\+|\\*)\\s+/i", $, $)) { $ = strlen($[1]); $ = strlen($[0]) - $; $['empty'] = 0; $ = false !== strpos('+-*', $[2]) ? 'ul' : 'ol'; if ($this->isBlock('list')) { if ($ < $[3][0] || $ == $[3][0] && $ != $[3][1]) { $this->startBlock('list', $, [$, $, $]); } else { $this->setBlock($); } } else { $this->startBlock('list', $, [$, $, $]); } return false; } return true; } public function parseBlockCode($, $, $, &$) { if (preg_match("/^(\\s*)(~{3,}|`{3,})([^`~]*)\$/i", $, $)) { if ($this->isBlock('code')) { if ($['code'] != $[2]) { $this->setBlock($); return false; } $ = $[3][2]; if ($) { $['empty'] = 0; $this->combineBlock()->setBlock($); } else { $this->setBlock($)->endBlock(); } } else { $ = false; if ($this->isBlock('list')) { $ = $[3][0]; $ = strlen($[1]) >= $ + $['empty']; } $['code'] = $[2]; $this->startBlock('code', $, array($[1], $[3], $)); } return false; } elseif ($this->isBlock('code')) { $this->setBlock($); return false; } return true; } public function parseBlockShtml($, $, $, &$) { if ($this->_html) { if (preg_match("/^(\\s*)!!!(\\s*)\$/", $, $)) { if ($this->isBlock('shtml')) { $this->setBlock($)->endBlock(); } else { $this->startBlock('shtml', $); } return false; } elseif ($this->isBlock('shtml')) { $this->setBlock($); return false; } } return true; } public function parseBlockAhtml($, $, $, &$) { if ($this->_html) { if (preg_match("/^\\s*<({$this->_blockHtmlTags})(\\s+[^>]*)?>/i", $, $)) { if ($this->isBlock('ahtml')) { $this->setBlock($); return false; } elseif (empty($[2]) || $[2] != '/') { $this->startBlock('ahtml', $); preg_match_all("/<({$this->_blockHtmlTags})(\\s+[^>]*)?>/i", $, $); $ = $[1][count($[0]) - 1]; if (strpos($, "</{$}>") !== false) { $this->endBlock(); } else { $['html'] = $; } return false; } } elseif (!!$['html'] && strpos($, "</{$['html']}>") !== false) { $this->setBlock($)->endBlock(); $['html'] = false; return false; } elseif ($this->isBlock('ahtml')) { $this->setBlock($); return false; } elseif (preg_match("/^\\s*<!\\-\\-(.*?)\\-\\->\\s*\$/", $, $)) { $this->startBlock('ahtml', $)->endBlock(); return false; } } return true; } public function parseBlockMath($, $, $) { if (preg_match("/^(\\s*)\\\$\\\$(\\s*)\$/", $, $)) { if ($this->isBlock('math')) { $this->setBlock($)->endBlock(); } else { $this->startBlock('math', $); } return false; } elseif ($this->isBlock('math')) { $this->setBlock($); return false; } return true; } public function parseBlockPre($, $, $, &$) { if (preg_match("/^ {4}/", $)) { if ($this->isBlock('pre')) { $this->setBlock($); } else { $this->startBlock('pre', $); } return false; } elseif ($this->isBlock('pre') && preg_match("/^\\s*\$/", $)) { $this->setBlock($); return false; } return true; } public function parseBlockHtml($, $, $, &$) { if (preg_match("/^\\s*<({$['special']})(\\s+[^>]*)?>/i", $, $)) { $ = strtolower($[1]); if (!$this->isBlock('html', $) && !$this->isBlock('pre')) { $this->startBlock('html', $, $); } return false; } elseif (preg_match("/<\\/({$['special']})>\\s*\$/i", $, $)) { $ = strtolower($[1]); if ($this->isBlock('html', $)) { $this->setBlock($)->endBlock(); } return false; } elseif ($this->isBlock('html')) { $this->setBlock($); return false; } return true; } public function parseBlockFootnote($, $, $) { if (preg_match("/^\\[\\^((?:[^\\]]|\\]|\\[)+?)\\]:/", $, $)) { $ = strlen($[0]) - 1; $this->startBlock('footnote', $, array($, $[1])); return false; } return true; } public function parseBlockDefinition($, $, $) { if (preg_match("/^\\s*\\[((?:[^\\]]|\\]|\\[)+?)\\]:\\s*(.+)\$/", $, $)) { $this->_definitions[$[1]] = $this->cleanUrl($[2]); $this->startBlock('definition', $)->endBlock(); return false; } return true; } public function parseBlockQuote($, $, $) { if (preg_match("/^(\\s*)>/", $, $)) { if ($this->isBlock('list') && strlen($[1]) > 0) { $this->setBlock($); } elseif ($this->isBlock('quote')) { $this->setBlock($); } else { $this->startBlock('quote', $); } return false; } return true; } public function parseBlockTable($, $, $, &$, $) { if (preg_match("/^((?:(?:(?:\\||\\+)(?:[ :]*\\-+[ :]*)(?:\\||\\+))|(?:(?:[ :]*\\-+[ :]*)(?:\\||\\+)(?:[ :]*\\-+[ :]*))|(?:(?:[ :]*\\-+[ :]*)(?:\\||\\+))|(?:(?:\\||\\+)(?:[ :]*\\-+[ :]*)))+)\$/", $, $)) { if ($this->isBlock('table')) { $[3][0][] = $[3][2]; $[3][2]++; $this->setBlock($, $[3]); } else { $ = 0; if (empty($) || $[0] != 'normal' || preg_match("/^\\s*\$/", $[$[2]])) { $this->startBlock('table', $); } else { $ = 1; $this->backBlock(1, 'table'); } if ($[1][0] == '|') { $[1] = substr($[1], 1); if ($[1][strlen($[1]) - 1] == '|') { $[1] = substr($[1], 0, -1); } } $ = preg_split("/(\\+|\\|)/", $[1]); $ = array(); foreach ($ as $) { $ = 'none'; if (preg_match("/^\\s*(:?)\\-+(:?)\\s*\$/", $, $)) { if (!empty($[1]) && !empty($[2])) { $ = 'center'; } elseif (!empty($[1])) { $ = 'left'; } elseif (!empty($[2])) { $ = 'right'; } } $[] = $; } $this->setBlock($, array(array($), $, $ + 1)); } return false; } return true; } public function parseBlockSh($, $, $) { if (preg_match("/^(#+)(.*)\$/", $, $)) { $ = min(strlen($[1]), 6); $this->startBlock('sh', $, $)->endBlock(); return false; } return true; } public function parseBlockMh($, $, $, &$, $) { if (preg_match("/^\\s*((=|-){2,})\\s*\$/", $, $) && ($ && $[0] == "normal" && !preg_match("/^\\s*\$/", $[$[2]]))) { if ($this->isBlock('normal')) { $this->backBlock(1, 'mh', $[1][0] == '=' ? 1 : 2)->setBlock($)->endBlock(); } else { $this->startBlock('normal', $); } return false; } return true; } public function parseBlockShr($, $, $) { if (preg_match("/^(\\* *){3,}\\s*\$/", $)) { $this->startBlock('hr', $)->endBlock(); return false; } return true; } public function parseBlockDhr($, $, $) { if (preg_match("/^(- *){3,}\\s*\$/", $)) { $this->startBlock('hr', $)->endBlock(); return false; } return true; } public function parseBlockDefault($, $, $, &$) { if ($this->isBlock('footnote')) { preg_match("/^(\\s*)/", $, $); if (strlen($[1]) >= $[3][0]) { $this->setBlock($); } else { $this->startBlock('normal', $); } } elseif ($this->isBlock('table')) { if (false !== strpos($, '|')) { $[3][2]++; $this->setBlock($, $[3]); } else { $this->startBlock('normal', $); } } elseif ($this->isBlock('quote')) { if (!preg_match("/^(\\s*)\$/", $)) { $this->setBlock($); } else { $this->startBlock('normal', $); } } else { if (empty($) || $[0] != 'normal') { $this->startBlock('normal', $); } else { $this->setBlock($); } } return true; } public function optimizeBlocks(array $, array $) { $ = $this->call('beforeOptimizeBlocks', $, $); $ = 0; while (isset($[$])) { $ = false; $ =& $[$]; $ = isset($[$ - 1]) ? $[$ - 1] : NULL; $ = isset($[$ + 1]) ? $[$ + 1] : NULL; list($, $, $) = $; if ('pre' == $) { $ = array_reduce(array_slice($, $[1], $[2] - $[1] + 1), function ($, $) { return preg_match("/^\\s*\$/", $) && $; }, true); if ($) { $[0] = $ = 'normal'; } } if ('normal' == $) { $ = array('list', 'quote'); if ($ == $ && preg_match("/^\\s*\$/", $[$]) && !empty($) && !empty($)) { if ($[0] == $[0] && in_array($[0], $) && ($[0] != 'list' || $[3][0] == $[3][0] && $[3][1] == $[3][1])) { $[$ - 1] = array($[0], $[1], $[2], $[3] ?? null); array_splice($, $, 2); $ = true; } } } if (!$) { $++; } } return $this->call('afterOptimizeBlocks', $, $); } public function parseCode(array $, array $, $) { list($, $) = $; $ = trim($); $ = strlen($); if (!preg_match("/^[_a-z0-9-\\+\\#\\:\\.]+\$/i", $)) { $ = NULL; } else { $ = explode(':', $); if (count($) > 1) { list($, $) = $; $ = trim($); $ = trim($); } } $ = true; $ = array_map(function ($) use($, &$) { $ = preg_replace("/^[ ]{{$}}/", '', $); if ($ && !preg_match("/^\\s*\$/", $)) { $ = false; } return htmlspecialchars($); }, array_slice($, 1, -1)); $ = implode("\n", $this->markLines($, $ + 1)); return $ ? '' : '<pre><code' . (!empty($) ? " class=\"{$}\"" : '') . (!empty($) ? " rel=\"{$}\"" : '') . '>' . $ . '</code></pre>'; } public function parsePre(array $, $, $) { foreach ($ as &$) { $ = htmlspecialchars(substr($, 4)); } $ = implode("\n", $this->markLines($, $)); return preg_match("/^\\s*\$/", $) ? '' : '<pre><code>' . $ . '</code></pre>'; } public function parseAhtml(array $, $, $) { return trim(implode("\n", $this->markLines($, $))); } public function parseShtml(array $, $, $) { return trim(implode("\n", $this->markLines(array_slice($, 1, -1), $ + 1))); } public function parseMath(array $, $, $, $) { return '<p>' . $this->markLine($, $) . htmlspecialchars(implode("\n", $)) . '</p>'; } public function parseSh(array $, $, $, $) { $ = $this->markLine($, $) . $this->parseInline(trim($[0], '# ')); return preg_match("/^\\s*\$/", $) ? '' : "<h{$}>{$}</h{$}>"; } public function parseMh(array $, $, $, $) { return $this->parseSh($, $, $, $); } public function parseQuote(array $, $, $) { foreach ($ as &$) { $ = preg_replace("/^\\s*> ?/", '', $); } $ = implode("\n", $); return preg_match("/^\\s*\$/", $) ? '' : '<blockquote>' . $this->parse($, true, $) . '</blockquote>'; } public function parseList(array $, $, $) { $ = ''; list($, $, $) = $; $ = array(); $ = ''; $ = 0; foreach ($ as $ => $) { if (preg_match("/^(\\s{" . $ . "})((?:[0-9]+\\.?)|\\-|\\+|\\*)(\\s+)(.*)\$/i", $, $)) { if ($ == 'ol' && $ == 0) { $ = intval($[2]); if ($ != 1) { $ = ' start="' . $ . '"'; } } $[] = [$[4]]; $ = count($) - 1; } else { $[$][] = preg_replace("/^\\s{" . ($ + $) . "}/", '', $); } } foreach ($ as $) { $ .= "<li>" . $this->parse(implode("\n", $), true, $) . "</li>"; $ += count($); } return "<{$}{$}>{$}</{$}>"; } public function parseTable(array $, array $, $) { list($, $) = $; $ = count($) > 0 && array_sum($) > 0; $ = '<table>'; $ = $ ? NULL : true; $ = false; foreach ($ as $ => $) { if (in_array($, $)) { if ($ && $) { $ = false; $ = true; } continue; } $ = trim($); $ = true; if ($[0] == '|') { $ = substr($, 1); if ($[strlen($) - 1] == '|') { $ = substr($, 0, -1); } } $ = array_map(function ($) { if (preg_match("/^\\s*\$/", $)) { return ' '; } else { return trim($); } }, explode('|', $)); $ = array(); $ = -1; foreach ($ as $) { if (strlen($) > 0) { $++; $[$] = array(isset($[$]) ? $[$][0] + 1 : 1, $); } elseif (isset($[$])) { $[$][0]++; } else { $[0] = array(1, $); } } if ($) { $ .= '<thead>'; } elseif ($) { $ .= '<tbody>'; } $ .= '<tr' . ($this->_line ? ' class="line" data-start="' . ($ + $) . '" data-end="' . ($ + $) . '" data-id="' . $this->_uniqid . '"' : '') . '>'; foreach ($ as $ => $) { list($, $) = $; $ = $ ? 'th' : 'td'; $ .= "<{$}"; if ($ > 1) { $ .= " colspan=\"{$}\""; } if (isset($[$]) && $[$] != 'none') { $ .= " align=\"{$[$]}\""; } $ .= '>' . $this->parseInline($) . "</{$}>"; } $ .= '</tr>'; if ($) { $ .= '</thead>'; } elseif ($) { $ = false; } } if ($ !== NULL) { $ .= '</tbody>'; } $ .= '</table>'; return $; } public function parseHr($, $, $) { return $this->_line ? '<hr class="line" data-start="' . $ . '" data-end="' . $ . '">' : '<hr>'; } public function parseNormal(array $, $, $) { foreach ($ as $ => &$) { $ = $this->parseInline($); if (!preg_match("/^\\s*\$/", $)) { $ = $this->markLine($ + $) . $; } } $ = trim(implode("\n", $)); $ = preg_replace_callback("/(\n\\s*){2,}/", function () use(&$) { $ = false; return "</p><p>"; }, $); $ = preg_replace("/\n/", "<br>", $); return preg_match("/^\\s*\$/", $) ? '' : ($ ? $ : "<p>{$}</p>"); } public function parseFootnote(array $, array $) { list($, $) = $; $ = array_search($, $this->_footnotes); if (false !== $) { $[0] = preg_replace("/^\\[\\^((?:[^\\]]|\\]|\\[)+?)\\]:/", '', $[0]); $this->_footnotes[$] = $; } return ''; } public function parseDefinition() { return ''; } public function parseHtml(array $, $, $) { foreach ($ as &$) { $ = $this->parseInline($, isset($this->_specialWhiteList[$]) ? $this->_specialWhiteList[$] : ''); } return implode("\n", $this->markLines($, $)); } public function cleanUrl($, $ = false) { $ = null; $ = trim($); if ($) { $ = strpos($, ' '); if ($ !== false) { $ = htmlspecialchars(trim(substr($, $ + 1), ' "\'')); $ = substr($, 0, $); } } $ = preg_replace("/[\"'<>\\s]/", '', $); if (preg_match("/^(mailto:)?[_a-z0-9-\\.\\+]+@[_\\w-]+(?:\\.[a-z]{2,})+\$/i", $, $)) { if (empty($[1])) { $ = 'mailto:' . $; } } if (preg_match("/^\\w+:/i", $) && !preg_match("/^(https?|mailto):/i", $)) { return '#'; } return $ ? [$, $] : $; } public function escapeBracket($) { return str_replace(array('\\[', '\\]', '\\(', '\\)'), array('[', ']', '(', ')'), $); } public function startBlock($, $, $ = NULL) { $this->_pos++; $this->_current = $; $this->_blocks[$this->_pos] = array($, $, $, $); return $this; } public function endBlock() { $this->_current = 'normal'; return $this; } public function isBlock($, $ = NULL) { return $this->_current == $ && (NULL === $ ? true : $this->_blocks[$this->_pos][3] == $); } public function getBlock() { return isset($this->_blocks[$this->_pos]) ? $this->_blocks[$this->_pos] : NULL; } public function setBlock($ = NULL, $ = NULL) { if (NULL !== $) { $this->_blocks[$this->_pos][2] = $; } if (NULL !== $) { $this->_blocks[$this->_pos][3] = $; } return $this; } public function backBlock($, $, $ = NULL) { if ($this->_pos < 0) { return $this->startBlock($, 0, $); } $ = $this->_blocks[$this->_pos][2]; $this->_blocks[$this->_pos][2] = $ - $; if ($this->_blocks[$this->_pos][1] <= $this->_blocks[$this->_pos][2]) { $this->_pos++; } $this->_current = $; $this->_blocks[$this->_pos] = array($, $ - $ + 1, $, $); return $this; } public function combineBlock() { if ($this->_pos < 1) { return $this; } $ = $this->_blocks[$this->_pos - 1]; $ = $this->_blocks[$this->_pos]; $[2] = $[2]; $this->_blocks[$this->_pos - 1] = $; $this->_current = $[0]; unset($this->_blocks[$this->_pos]); $this->_pos--; return $this; } }